#ifndef CONFIGURATION_H
#define CONFIGURATION_H


#include <vector>
#include <cmath>


//problems
#define	ACKLEY			0
#define	GRIEWANK		1
#define	RASTRIGIN		2
#define	ROSENBROCK	3
#define 	EXTSCHAFFER	4
#define	SCHWEFEL		5
#define	SALOMON		6
#define	SPHERE			7	
#define  	STEP			8
#define  	WEIERSTRASS	9


#define PI acos(-1) 
#define E  exp(1)

#define DELTA 1E-30

class Configuration {
	
      private:

	//general parameters     
	unsigned long rngSeed;
	unsigned int maxFES; 
	
	//problem parameters
	unsigned int problemID;
	unsigned int problemDimension;    
	bool randomlyShifted;
	bool minimization;
	double minInitRange;
	double maxInitRange;
	
	//swarm parameters
	unsigned int populationSize;   			

	double initialIW;
	double finalIW;
	unsigned int iwSchedule;
	unsigned int tSchedule;
       
      public:

	Configuration(int argc,char** argv);
	~Configuration();
	
	unsigned long getRNGSeed();
	unsigned int getMaxFES();
	
	unsigned int getProblemID();
	unsigned int getProblemDimension();
	bool isRandomlyShifted();
	bool isMinimization();
	double getMinInitRange();
	double getMaxInitRange();
	
	unsigned int getPopulationSize();	

	double getInitialIW();
	double getFinalIW();
	unsigned int getIWSchedule();

	unsigned int getTopologySchedule();

	void print();	
};

#endif
