#include "rng.h"
#include "problem.h"
#include "configuration.h"

#include <iostream>
#include <cstdlib>

#include <values.h>
#include <float.h>

using namespace std;

Problem::Problem(Configuration* config){
	this->config = config;
	evaluations = 0;
	dimension = config->getProblemDimension();
	isShifted = config->isRandomlyShifted();
	maxEvaluations = config->getMaxFES();	

	minimization = config->isMinimization();
	if(minimization)
		bestSolutionValue = MAXDOUBLE;
	else
		bestSolutionValue = -MAXDOUBLE;			
}

Problem::~Problem(){}
	
int Problem::getProblemDimension() { return dimension; }
double Problem::getProblemOptimum() { return optimum; }

unsigned int Problem::getFunctionEvaluations(){ return evaluations; }

double Problem::getBestSolution(){return bestSolutionValue;}

void Problem::printProgress(){
// 	printf("%d\t%d\t%e\n",evaluations/config->getPopulationSize(),evaluations,bestSolutionValue);
	printf("%d\t%1.10e\n",evaluations,bestSolutionValue);
}
