#ifndef PROBLEM_H
#define PROBLEM_H

#include "configuration.h"
#include <cmath>

class Problem {
	
      protected:
	Configuration* config;
	int dimension;	
	bool isShifted;
	unsigned int evaluations;	
	unsigned int maxEvaluations;
	double optimum;
	double oldResult;	

	bool minimization;
	double bestSolutionValue;

      public:

	 Problem(Configuration* config);
	 virtual ~Problem();
	
	int getProblemDimension();
	double getProblemOptimum();

	unsigned int getFunctionEvaluations();
	
	//Evaluation call
	virtual double getFunctionValue(const double* x) = 0;		

	double getBestSolution();

	void printProgress();

};


#endif

