#ifndef PSO_H
#define PSO_H

#include "configuration.h"
#include "swarm.h"
#include "problem.h"

class PSO {
	    
      protected:
	Configuration* config;	
	Swarm* s;
	Problem* p;	
	
      public:
	PSO(Configuration* config, Swarm* swarm, Problem* problem);
 	virtual ~PSO();

	virtual bool notDone() = 0;		

	double limitVelocity(double vel);
	double clampPosition(double candidate);	
	double clampPositionVelocity(double candidate,double* velocity);	
	double reboundPosition(double candidate,double* velocity);

	virtual void run() = 0;		
			
	void printSolution();
		
};

#endif

