#ifndef SWARM_H
#define SWARM_H

#include "rng.h"
#include "configuration.h"
#include "problem.h"
#include "particle.h"

#include <vector>

class Swarm {
	
      private:
	Configuration* config;	
	int numberOfParticles;
	std::vector<Particle*> particles;				
	
      public:

	 Swarm(Configuration* config,Problem* problem);
	 ~Swarm();

	int getSize();	
	Particle* getParticle(int id);
	Particle* getBestNeighborOf(Particle* p);
	
	double getSolutionValue();
	const double* getSolution();
	Particle* getBestParticle();
	Particle* getRandomParticle();
	
	double getAvgDist2Centroid();
	double getAvgSpeed();
	
	void print();	
};


#endif
